-- X8R, X4R configuration program for use with the firmware developed by Mike Blandford

local splashTime = 20 --<< Change value for splash screen timeout at startup (value of 20 = 1 second)
local txid = 0x17
local now = getTime() -- 50
local item = 0
local Hitem = 0
local Sitem = 0
local Rate = 0
local Crates = 0
local Chans9_16 = 0
local Sbus4Value = 0
local TuneValue = 0
local TuneOffset = 0
local NineMsRead = 0
local CratesRead = 0
local ChansRead = 0
local Sbus4Read = 0
local TuneRead = 0
local TuneOffRead = 0
local Page = 0
local SelectedItem = 0
local keepAlive = 1
local skipCrates = 0
local EditValue = 0
local OldValue = 0
local midpx = LCD_W / 2
local txtSiz = 0
local advRow = 0
local start = 0
--local Uid0 = 0
--local Uid1 = 0
local line = 0
local Resetting = 0
local HexChars = {}
local HexText = {}
local Id0Value = 0
local Id0Read = 0
local Id1Value = 0
local Id1Read = 0
local Id2Value = 0
local Id2Read = 0
local Id3Value = 0
local Id3Read = 0
local Id4Value = 0
local Id4Read = 0
local ValidValue = 0
local ValidRead = 0
local Code = {}
local SendingCode = 0
local UpdateValue = 0


local function toHex(value)
	HexText = HexChars[bit32.band(value/4096, 0x000F)]
	HexText = HexText .. HexChars[bit32.band(value/256, 0x000F)]
	HexText = HexText .. HexChars[bit32.band(value/16, 0x000F)]
	HexText = HexText .. HexChars[bit32.band(value, 0x000F)]
end

local function upField()
	if EditValue > 0 then
		if SelectedItem < 6 then
			x = Code[SelectedItem]
		   if x > 0 then
				x = x - 1
		   end
			Code[SelectedItem] = x
		end
	else
		if SelectedItem > 0 then
			SelectedItem = SelectedItem - 1
		else
			SelectedItem = 6
		end
	end
end

local function downField()
	if EditValue > 0 then
		if SelectedItem < 6 then
			x = Code[SelectedItem]
		   if x < 15 then
				x = x + 1
		   end
			Code[SelectedItem] = x
		end
	else
		SelectedItem = SelectedItem + 1
		if SelectedItem > 6 then
			SelectedItem = 0
		end
	end
end

local function sendWrite(value)
	result = sportTelemetryPush(txid, 0x31, 0x0C20, value)
	return result
end

	-- Page-0 RX Setup --
local function changeSetup()
	if SelectedItem == 6 then
		SendingCode = 3
		now = getTime()
	elseif EditValue == 0 then
		EditValue = 1
	else
		EditValue = 0
	end
end

local function sendRead(value)
	result = sportTelemetryPush(txid, 0x30, 0x0C20, value)
	return result
end

local function refreshSetup()
	if getTime() - now > 60 then
		now = now + 60
		keepAlive = 0
		if Id0Read == 0 then
			result = sendRead(0x0CFF)
		elseif Id1Read == 0 then
			result = sendRead(0x0DFF)
		elseif Id2Read == 0 then
			result = sendRead(0x0EFF)
		elseif Id3Read == 0 then
			result = sendRead(0x0FFF)
		elseif Id4Read == 0 then
			result = sendRead(0x10FF)
		elseif ValidRead == 0 then
			result = sendRead(0xEB)
		else
			i = 0
		end
		if result == 0 then
			now = now - 60
		end
	 	if SendingCode > 0 then
 	 		if SendingCode == 3 then
				UpdateValue = Code[0] + Code[1] * 256
				UpdateValue = UpdateValue * 65536
				UpdateValue = UpdateValue + 0xEB
				result = sportTelemetryPush(txid, 0x31, 0x0C20, UpdateValue)
				if result ~= 0 then
					SendingCode = 2
				end
 	 		elseif SendingCode == 2 then
				UpdateValue = Code[2] + Code[3] * 256
				UpdateValue = UpdateValue * 65536
				UpdateValue = UpdateValue + 0x1EB
				result = sportTelemetryPush(txid, 0x31, 0x0C20, UpdateValue)
				if result ~= 0 then
					SendingCode = 1
				end
 	 		elseif SendingCode == 1 then
				UpdateValue = Code[4] + Code[5] * 256
				UpdateValue = UpdateValue * 65536
				UpdateValue = UpdateValue + 0x2EB
				result = sportTelemetryPush(txid, 0x31, 0x0C20, UpdateValue)
				if result ~= 0 then
					SendingCode = 0
					ValidRead = 0
				end
			end
		end
	else
		if keepAlive ~= 0 then
			result = sportTelemetryPush(txid, 0, 0, 0)
		end
	end

	local physicalId, primId, dataId, value = sportTelemetryPop()
	if primId ~= nil then
		if primId == 0x32 then
			if dataId == 0x0C20 then
				if ValidRead == 0 then keepAlive = 1 end
				x = bit32.band(value, 0x00FF)
				if x == 0x00FF then
					value = value / 256
					x = bit32.band(value, 0x00FF)
					value = value / 256
					if x == 12 then
			      Id0Value = value
      			Id0Read = 1
					end
					if x == 13 then
			      Id1Value = value
			      Id1Read = 1
					end
					if x == 14 then
			      Id2Value = value
			      Id2Read = 1
					end
					if x == 15 then
			      Id3Value = value
			      Id3Read = 1
					end
					if x == 16 then
			      Id4Value = value
			      Id4Read = 1
					end
				else
					if x == 0x00EB then
						value = value / 256
						ValidValue = bit32.band(value, 0x00FF)
						ValidRead = 1
					end
					now = getTime() - 55
				end
			end
		end
		refreshState = 0
	end
end

local function page0()
	lcd.drawText( 0, 0,"RX Activation", txtSiz)

	if Id1Read == 1 then
		toHex( Id1Value )
		lcd.drawText( 0, hfpx*2, HexText, txtSiz )
	end
	if Id2Read == 1 then
		toHex( Id2Value )
		lcd.drawText( wfpx*4, hfpx*2, HexText, txtSiz )
	end
	if Id3Read == 1 then
		toHex( Id3Value )
		lcd.drawText( wfpx*8, hfpx*2, HexText, txtSiz )
	end

	lcd.drawText( 0, hfpx*4, "Code:", txtSiz )

	if ValidRead == 1 then
		if ValidValue > 0 then
	   	lcd.drawText( 0, hfpx*3, "Activated", txtSiz )
		else
	   	lcd.drawText( 0, hfpx*3, "Locked", txtSiz )
		end
	end

	i = 0
	while i < 6 do
		attr = txtSiz
		if SelectedItem == i then attr = INVERS + txtSiz end
		lcd.drawText( wfpx*(i+6), hfpx*4, HexChars[Code[i]], attr )
		i = i + 1
	end

	attr = 0
	if SelectedItem == 6 then attr = INVERS + txtSiz end
 	lcd.drawText( 0, hfpx*6, "Send", attr )

	if SendingCode > 0 then
 		lcd.drawText( 0, hfpx*7, "Sending Code", txtSiz )
	end
end	-- END RX Setup Page-0 --

local function splash()
	lcd.drawText(midpx-wfpx*7.6, hfpx,"RX Activation", bigSiz)
	lcd.drawText(midpx-wfpx*3.5, hfpx*2.6, "(Version 1)", txtSiz)
	lcd.drawText(midpx-wfpx*7.7, hfpx*5,"RXxR Series RX", txtSiz)
	lcd.drawText(midpx-wfpx*7.8, hfpxLast, "Developer MikeBlandford", txtSiz)
	start = start + 1
end

local function change()
	changeSetup()
end

	-- Initialization table --
local function init()

	HexChars[0] = "0"
	HexChars[1] = "1"
	HexChars[2] = "2"
	HexChars[3] = "3"
	HexChars[4] = "4"
	HexChars[5] = "5"
	HexChars[6] = "6"
	HexChars[7] = "7"
	HexChars[8] = "8"
	HexChars[9] = "9"
	HexChars[10] = "A"
	HexChars[11] = "B"
	HexChars[12] = "C"
	HexChars[13] = "D"
	HexChars[14] = "E"
	HexChars[15] = "F"

	Code[0] = 8
	Code[1] = 8
	Code[2] = 8
	Code[3] = 8
	Code[4] = 8
	Code[5] = 8

	if LCD_H == 64 then
	hfpx = 8
	hfpxLast = hfpx*7
	else hfpx = 27.2
	hfpxLast = hfpx*9
	end

	if LCD_W == 480 then
	posrep = 204
	wfpx = 18
	txtSiz = MIDSIZE
	smSiz = 0
	bigSiz = DBLSIZE
	else
	posrep = 90
	wfpx = 8
	txtSiz = 0
	smSiz = SMLSIZE
	bigSiz = MIDSIZE
	end
end

local function run(event)
	lcd.clear()
	local ver, radio, maj, minor, rev = getVersion()
	if minor >= 3 then
		-- All Radios - Virtual Events
		if event == EVT_VIRTUAL_ENTER then change()
		elseif event == EVT_VIRTUAL_PREV then upField()
		elseif event == EVT_VIRTUAL_PREV_REPT then upField()
		elseif event == EVT_VIRTUAL_NEXT then downField()
		elseif event == EVT_VIRTUAL_NEXT_REPT then downField()
		end
	else
		-- X9D
		if event == EVT_ENTER_BREAK then change()
		elseif event == EVT_PLUS_FIRST then upField()
		elseif event == EVT_PLUS_REPT then upField()
		elseif event == EVT_MINUS_FIRST then downField()
		elseif event == EVT_MINUS_REPT then downField()
		-- X10, X7
		elseif event == EVT_ROT_LEFT then upField()
		elseif event == EVT_ROT_RIGHT then downField()
		-- X-Lite
		elseif event == 100 then upField()
		elseif event == 68 then upField()
		elseif event == 99 then downField()
		elseif event == 67 then downField()
		end
	end

	if start < splashTime then
		splash()
	else
		refreshSetup()
		page0()
	end
	return 0
end
return {run=run, init=init}